<template>
  <div class="v-input">
    <div class="v-input-head">
      <p v-if="name" class="v-input-name">{{name}}</p>
      <p v-if="subName" class="v-input-subname subtitle">{{subName}}</p>
    </div>
    <p v-if="subtitle" class="v-input-subtitle subtitle">{{subtitle}}</p>
    <label
      :class="{'rubles': rubles, 'rublesMonth': rublesMonth,}"
      :style="{width: width+'%'}">
      <input
        v-if="input"
        :type="inputType"
        :placeholder="placeholder"
        :class="{'rightTextInput': rightText }"
      ><span class="rightTextInput">{{rightText}}</span>
      <div v-if="visible" class="v-input-visible">
        <label>
          <input v-model="checkVisible" type="checkbox">
          <span :class="{'blue': checkVisible}">видимый в контактах</span>
        </label>
      </div>
      <div class="dblinput" v-if="dblinput">
        <input style="margin-right: 16px" :type="inputType" :placeholder="dblPlaceholder[0]">
        <input :type="inputType" :placeholder="dblPlaceholder[1]">
      </div>
      <v-select :top="selectTop" :value="checked" :list="selectOptions" v-if="select"/>
      <select v-if="1===2">
        <slot name="selectOption">Default body</slot>
      </select>
      <textarea v-if="textarea" :placeholder="placeholder"/>
      <div v-if="switches" class="switches-wrap">
        <p :class="{active: !localSwitches}">{{switchesList[0]}}</p>
        <div class="switches">
          <label><input v-model="localSwitches" type="checkbox" class="ios-switch bigswitch" checked />
            <div>
              <div></div>
            </div>
          </label>
        </div>
        <p :class="{active: localSwitches}">{{switchesList[1]}}</p>
      </div>
    </label>
  </div>
</template>

<script>
import vSelect from './V-Select'
export default {
  name: "Input",
  components: {
    'v-select': vSelect
  },
  data () {
    return {
      checkVisible: false,
      localSwitches: false
    }
  },
  props: {
    input: Boolean,
    select: Boolean,
    textarea: Boolean,
    dblinput: Boolean,
    switches: Boolean,
    rubles: {
      type: Boolean,
      default: false
    },
    rublesMonth: {
      type: Boolean,
      default: false
    },
    switchesList: {
      type: Array,
      default: ()=>{
        return ['Да', 'Нет']
      }
    },
    visible: {
      type: Boolean,
      default: false
    },
    dblPlaceholder: {
      type: Array,
      default: () => ['', '']
    },
    inputType: {
      type: String,
      default: 'text'
    },
    selectTop: {
      type: Boolean,
      default: false
    },
    rightText: String,
    selectOptions: Array,
    checked: String,
    placeholder: {
      type: String,
      default: ''
    },
    name: String,
    subName: String,
    subtitle: String,
    width: {
      type: Number,
      default: 100
    },
  }
}
</script>

<style scoped lang="scss">
.v-input {
  margin-bottom: 24px;
  .v-input-head {
    margin-bottom: 12px;
    display: flex;
    align-items: center;
    .v-input-name {
      font-weight: 700;
      font-size: 18px;
      line-height: 120%;
      margin-right: 12px;
    }
  }
  .v-input-subtitle {
    margin-bottom: 8px;
  }
  .dblinput {
    display: flex;
    align-items: center;
    justify-content: space-between;
  }
  label, .dblinput {
    position: relative;
    &.rubles :before {
      content: '';
      position: absolute;
      width: 12px;
      height: 16px;
      right: 10px;
      top: 0px;
      background: url("../assets/images/icons/rubles.svg") center;
      background-size: cover;
    }
    &.rublesMonth :before {
      content: '';
      position: absolute;
      width: 50px;
      height: 16px;
      right: 10px;
      top: 0px;
      background: url("../assets/images/icons/rubles-month.svg") center;
      background-size: cover;
    }
    input, select, textarea {
      background: #FFFFFF;
      border: 2px solid #97C1F2;
      box-sizing: border-box;
      border-radius: 12px;
      padding: 10px 0 10px 12px;
      color: #838383;
      width: 100%;
      &::placeholder {
        color: #838383;
      }
    }
    .rightTextInput {
    }
    textarea {
      height: 150px;
    }
  }
  input.rightTextInput {
    width: 88%;
    margin-right: 12px;
  }
  .v-input-visible {
    display: flex;
    margin-top: 14px;
    label {
      display: flex;
      width: 100%;
      input {
        width: initial;
        margin-right: 8px;
      }
      span {
        color: #C4C4C4;
        &.blue {color: #2B7FE2;}
      }
    }
  }
  .switches-wrap {
    display: flex;
    align-items: center;
    p {
      width: 55px;
      &.active {
        font-weight: 700;
        font-size: 16px;
        line-height: 120%;
        color: #2B7FE2;
      }
    }
    .switches {
      width: 70px;
      display: flex;
      justify-content: center;
      input {width: initial}
      input[type="checkbox"] {
        position: absolute;
        opacity: 0;
      }

      /* Normal Track */
      input[type="checkbox"].ios-switch + div {
        vertical-align: middle;
        width: 40px;	height: 20px;
        border-radius: 999px;
        background-color: #3b89ec;
        -webkit-transition-duration: .4s;
        -webkit-transition-property: background-color, box-shadow;
        box-shadow: inset 0 0 0 0px rgba(0,0,0,0.4);
        margin: 0 2.5em 0 2.5em;
      }

      /* Checked Track (Blue) */
      input[type="checkbox"].ios-switch:checked + div {
        width: 40px;
        background-position: 0 0;
        background-color: #3b89ec;
        box-shadow: inset 0 0 0 10px rgba(59,137,259,1);
      }
      /* Big Track */
      input[type="checkbox"].bigswitch.ios-switch + div {
        width: 48px;	height: 24px;
      }

      /* Normal Knob */
      input[type="checkbox"].ios-switch + div > div {
        float: left;
        width: 18px; height: 18px;
        border-radius: inherit;
        background: #ffffff;
        -webkit-transition-timing-function: cubic-bezier(.54,1.85,.5,1);
        -webkit-transition-duration: 0.4s;
        -webkit-transition-property: transform, background-color, box-shadow;
        -moz-transition-timing-function: cubic-bezier(.54,1.85,.5,1);
        -moz-transition-duration: 0.4s;
        -moz-transition-property: transform, background-color;
        box-shadow: 0px 2px 5px rgba(0, 0, 0, 0.3), 0px 0px 0 1px rgba(0, 0, 0, 0.4);
        pointer-events: none;
        margin-top: 2px;
        margin-left: 4px;
      }
      /* Big Knob */
      input[type="checkbox"].bigswitch.ios-switch + div > div {
        width: 16px; height: 16px;
        margin-top: 4px;
      }

      /* Checked Big Knob (Blue Style) */
      input[type="checkbox"].bigswitch.ios-switch:checked + div > div {
        -webkit-transform: translate3d(25px, 0, 0);
        -moz-transform: translate3d(16px, 0, 0);
        box-shadow: 0px 4px 8px rgba(0, 0, 0, 0.3), 0px 0px 0 1px rgba(8, 80, 172,1);
      }

      /* Green Knob */
      input[type="checkbox"].green.ios-switch:checked + div > div {
        box-shadow: 0px 2px 5px rgba(0, 0, 0, 0.3), 0 0 0 1px rgba(0, 162, 63,1);
      }
    }
  }
}
</style>
